package com.gemho.netty.controller;

import com.gemho.netty.model.ResultModel;
import com.gemho.netty.util.*;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;


public class nettyHandler extends ChannelInboundHandlerAdapter {

    @Override
    public void channelActive(ChannelHandlerContext ctx) {
        System.out.println("当前连接信息:" + ctx.channel().remoteAddress());
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        System.out.println("返回指令===========" + msg.toString());
        if (msg.toString().length() == 30) {
            String IMEICode = new String(StringUtil.hexString2Bytes(msg.toString()));
            System.out.println("连接的IMEI码:" + IMEICode);
            if (MapUtils.judgeChannel(IMEICode)) {
                // 有重复的IMEI连接
                MapUtils.replaceChannel(IMEICode, ctx.channel());
            } else {
                // 无重复连接
                MapUtils.addMap(IMEICode, ctx.channel());
            }
        }else {
            byte[] bys = StringUtil.hexString2Bytes(msg.toString());
            int i = CRC16Util.calcCrc16(bys, 0, 6);
            if (StringUtil.hightAddZero(Integer.toHexString(i).toUpperCase()).equals(StringUtil.bytesToHexString(bys).substring(12))){
                System.out.println("CRC校验通过!");
                /*src：byte源数组
                srcPos：截取源byte数组起始位置（0位置有效）
                dest,：byte目的数组（截取后存放的数组）
                destPos：截取后存放的数组起始位置（0位置有效）
                length：截取的数据长度*/
                byte[] newBys = new byte[1];
                System.arraycopy(bys, 5, newBys, 0, 1);
                System.out.println("==============result:" + StringUtil.bytesToHexString(newBys));
                if ("00".equals(StringUtil.bytesToHexString(newBys))) {
                    System.out.println("正常:大屏接收到数据");
                } else {
                    byte[] typeByte = new byte[2];
                    System.arraycopy(bys, 1, typeByte, 0, 2);
                    System.out.println("0000:清屏异常==0001:屏幕显示异常============返回异常信息指令:" + StringUtil.bytesToHexString(typeByte));
                    if ("0001".equals(StringUtil.bytesToHexString(typeByte))) {
                        this.processResult("display" + ctx.channel().remoteAddress().toString(), ctx);
                    } else {
                        this.processResult("clear" + ctx.channel().remoteAddress().toString(), ctx);
                    }
                }
            }else {
                System.out.println("CRC校验失败！");
            }
        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        System.out.println("异常信息:" + cause.getMessage());
        ctx.channel().closeFuture().sync();
    }

    /**
     *
     * @param ctx 连接通道
     * @param evt 事件
     */
    @Override
    public void userEventTriggered(ChannelHandlerContext ctx, Object evt) {

    }

    /**
     *
     * @param Key clear-address
     * @param ctx 通道
     * @throws Exception 异常
     */
    private void processResult(String Key, ChannelHandlerContext ctx) throws Exception{
        ResultModel map = ParamUtil.findMap(Key);
        if (map != null) {
            int count = map.getCount();
            for (int j = 0; j < 4 - map.getCount(); j++) {
                if (count == 3) {
                    System.out.println(Key + "错误:大屏未接收到数据, 连接关闭！");
                    ParamUtil.removeMap(Key);
                    ctx.channel().close().sync();
                    return;
                } else {
                    byte[] hexCodeByte = map.getHexCodeByte();
                    ByteBuf byteBuf = Unpooled.buffer();
                    byteBuf.writeBytes(hexCodeByte);
                    ctx.writeAndFlush(byteBuf);
                    count += 1;
                    System.out.println("repeat send......." + count);
                }
            }
        }
    }

}
